%define anolis_release 1
%bcond_with tests

Name:           libcgroup
Version:        3.1.0
Release:        %{anolis_release}%{?dist}
Summary:        iLibrary to control and monitor control groups
License:        LGPLv2+
URL:            http://libcg.sourceforge.net/
Source0:        https://github.com/%{name}/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:        cgconfig.service

#Patch0001:      0001-libcgroup-0.37-chmod.patch
#Patch0002:      0002-libcgroup-0.40.rc1-coverity.patch
#Patch0003:      0003-libcgroup-0.40.rc1-fread.patch
#Patch0004:      0004-libcgroup-0.40.rc1-templates-fix.patch
#PATCH1001:      0001-1001-libcgroup-tests-unbundle-gtest.patch
#1001-libcgroup-tests-unbundle-gtest.patch

BuildRequires:  make gcc-c++ gcc libtool automake autoconf gcc
BuildRequires:  gtest-devel pam-devel 
BuildRequires:  systemd-devel byacc coreutils flex
#systemd-units byacc coreutils flex
Requires(pre):  shadow-utils
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
Control groups infrastructure. The library helps manipulate, control,
administrate and monitor control groups and the associated controllers.

%package        devel
Summary:        Development libraries to develop applications that utilize control groups
Requires:       %{name} = %{version}-%{release}

%description    devel
It provides API to create/delete and modify cgroup nodes. It will also in the
future allow creation of persistent configuration for control groups and
provide scripts to manage that configuration.

%package        tools
Summary:        Command-line utility programs, services and daemons for libcgroup
Requires:       %{name} = %{version}-%{release}
Requires:       systemd >= 217-0.2

%description    tools
This package contains command-line programs, services and a daemon for
manipulating control groups using the libcgroup library.

%package        pam
Summary:        A Pluggable Authentication Module for libcgroup
Requires:       %{name} = %{version}-%{release}

%description    pam
Linux-PAM module, which allows administrators to classify the user's login
processes to pre-configured control group.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup  -p1  -n %{name}-%{version}

%build
autoreconf -vif
%configure --enable-pam-module-dir=%{_libdir}/security \
           --enable-opaque-hierarchy="name=systemd" \
           --disable-daemon 
#\
#           --disable-static
%make_build

%install
%make_install

#mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}
#install -m 0644 -p samples/config/cgsnapshot_blacklist.conf $RPM_BUILD_ROOT/%{_sysconfdir}/cgsnapshot_blacklist.conf
install -d %{buildroot}%{_sysconfdir}
install -m 0644 -p samples/config/cgconfig.conf $RPM_BUILD_ROOT/%{_sysconfdir}/cgconfig.conf
install -m644 samples/config/cgsnapshot_denylist.conf %{buildroot}/%{_sysconfdir}/cgsnapshot_denylist.conf

rm -f $RPM_BUILD_ROOT%{_libdir}/security/pam_cgroup.{,l}a 
rm -f $RPM_BUILD_ROOT/%{_libdir}/libcgroupfortesting.*
rm -f $RPM_BUILD_ROOT/%{_libdir}/*.{,l}a

rm -f $RPM_BUILD_ROOT/%{_mandir}/man8/cgrulesengd.8*
rm -f $RPM_BUILD_ROOT/%{_mandir}/man5/cgrules.conf.5*
rm -f $RPM_BUILD_ROOT/%{_mandir}/man5/cgred.conf.5*

#mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
#mkdir -p ${RPM_BUILD_ROOT}%{_unitdir}
install -d %{buildroot}%{_unitdir}
install -m 0644 -p %SOURCE1 ${RPM_BUILD_ROOT}%{_unitdir}/
install -d %{RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig

#%%generate_compatibility_deps

%if %{with tests}
%check
make -C tests/gunit check
%endif

%post tools
%systemd_post cgconfig.service

%preun tools
%systemd_preun cgconfig.service

%postun tools
%systemd_postun_with_restart cgconfig.service

#%%triggerun -- libcgroup < 0.38
#/usr/bin/systemd-sysv-convert --save cgconfig >/dev/null 2>&1 ||:

#/sbin/chkconfig --del cgconfig >/dev/null 2>&1 || :
#/bin/systemctl try-restart cgconfig.service >/dev/null 2>&1 || :

%files
#%%dir %{abidir}
%{!?_licensedir:%global license %%doc}
%license COPYING
%{_libdir}/libcgroup.so.3*
#%%{abidir}/libcgroup.dump

%files tools
%{!?_licensedir:%global license %%doc}
%license COPYING
#%%config(noreplace) %{_sysconfdir}/cgsnapshot_blacklist.conf
%config(noreplace) %{_sysconfdir}/cgsnapshot_denylist.conf
%config(noreplace) %{_sysconfdir}/cgconfig.conf
%{_bindir}/cgcreate
#%%{abidir}/cgcreate-option.list
%{_bindir}/cgset
#%%{abidir}/cgset-option.list
%{_bindir}/cgget
#%%{abidir}/cgget-option.list
%{_bindir}/cgxset
#%%{abidir}/cgxset-option.list
%{_bindir}/cgxget
#%%{abidir}/cgxget-option.list
%{_bindir}/cgdelete
#%%{abidir}/cgdelete-option.list
%{_bindir}/lssubsys
#%%{abidir}/lssubsys-option.list
%{_bindir}/lscgroup
#%%{abidir}/lscgroup-option.list
%{_bindir}/cgsnapshot
#%%{abidir}/cgsnapshot-option.list
%{_sbindir}/cgconfigparser
#%%{abidir}/cgconfigparser-option.list
%{_bindir}/cgclassify
#%%{abidir}/cgclassify-option.list
%{_bindir}/libcgroup_systemd_idle_thread
%attr(0755, root, root) %{_bindir}/cgexec
#%%{abidir}/cgexec-option.list
%{_unitdir}/cgconfig.service
%attr(0644, root, root) %{_mandir}/man8/*
%attr(0644, root, root) %{_mandir}/man5/*
%attr(0644, root, root) %{_mandir}/man1/*

%files pam
%{!?_licensedir:%global license %%doc}
%license COPYING
%attr(0755,root,root) %{_libdir}/security/pam_cgroup.so
#%%{abidir}/pam_cgroup.dump

%files devel
%{!?_licensedir:%global license %%doc}
%license COPYING
%{_libdir}/pkgconfig/libcgroup.pc
%{_libdir}/libcgroup.so

%{_includedir}/libcgroup/*.h
%{_includedir}/libcgroup.h

%files doc
%doc README README_systemd

%changelog
* Fri Dec 13 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.1.0-1
- update to 3.1.0

* Wed Apr 12 2023 Guyu Wang <guyu.wgy@linux.alibaba.com> - 3.0.0-1
- Update to 3.0.0

* Tue Mar  8 2022 forrest_ly <flin@linux.alibaba.com> - 2.0-1
- Init for Anolis OS 23 
